--[[************************************************************************************************************************************************************
	
	multiTrailer v1.5.5 ... Events for MP and DS
	
	"Farming Simulator 2013" & "Farming Simulator 2013 MORE REALISTIC" & "Farming Simulator 2015"
	
	06/2015 © Saty MODS (Saty / http://forum.lsczech.cz)
	
****************************************************************************************************************************************************************
	
	(EN) INFO
	
	Free for use on mods. Modifications only with my permission !
	
	This work is licensed under a Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International License (Attribution / NonCommercial / NoDerivatives)
	http://creativecommons.org/licenses/by-nc-nd/4.0/deed.en
	
****************************************************************************************************************************************************************
	
	(CZ) INFO
	
	Pro volne pouziti v modech. ZAKAZ modifikaci bez meho souhlasu !
	
	Toto dilo podleha licenci : Creative Commons 4.0 International - Uvedte autora / Neuzivejte dilo komercne / Nezasahujte do dila 
	http://creativecommons.org/licenses/by-nc-nd/4.0/deed.cs
	
************************************************************************************************************************************************************]]--

multiTrailerEvent = {};
multiTrailerEvent_mt = Class(multiTrailerEvent, Event);

InitEventClass(multiTrailerEvent, "multiTrailerEvent");

function multiTrailerEvent:emptyNew()
	local self = Event:new(multiTrailerEvent_mt);
	self.className="multiTrailerEvent";
	return self;
end;

function multiTrailerEvent:new(vehicle, state)
	local self = multiTrailerEvent:emptyNew()
	self.vehicle = vehicle;
	self.state = state;
	return self;
end;

function multiTrailerEvent:readStream(streamId, connection)
	local id = streamReadInt32(streamId);
	self.state = streamReadInt8(streamId);
	self.vehicle = networkGetObject(id);
	self:run(connection);
end;

function multiTrailerEvent:writeStream(streamId, connection)
	streamWriteInt32(streamId, networkGetObjectId(self.vehicle));
	streamWriteInt8(streamId, self.state);
end;

function multiTrailerEvent:run(connection)
	self.vehicle:changeCurrentBody(self.state, true);
	if not connection:getIsServer() then
		g_server:broadcastEvent(multiTrailerEvent:new(self.vehicle, self.state), nil, connection, self.vehicle);
	end;
end;

function multiTrailerEvent.sendEvent(vehicle, state, noEventSend)
	if state ~= vehicle.multiT.currentBody then
		if noEventSend == nil or noEventSend == false then
			if g_server ~= nil then
				g_server:broadcastEvent(multiTrailerEvent:new(vehicle, state), nil, nil, vehicle);
			else
				g_client:getServerConnection():sendEvent(multiTrailerEvent:new(vehicle, state));
			end;
		end;
	end;
end;


SetCoverSheetEvent = {};
SetCoverSheetEvent_mt = Class(SetCoverSheetEvent, Event);

InitEventClass(SetCoverSheetEvent, "SetCoverSheetEvent");

function SetCoverSheetEvent:emptyNew()
	local self = Event:new(SetCoverSheetEvent_mt);
	self.className="SetCoverSheetEvent";
	return self;
end;

function SetCoverSheetEvent:new(vehicle, state)
	local self = SetCoverSheetEvent:emptyNew()
	self.vehicle = vehicle;
	self.state = state;
	return self;
end;

function SetCoverSheetEvent:readStream(streamId, connection)
	local id = streamReadInt32(streamId);
	self.state = streamReadBool(streamId);
	self.vehicle = networkGetObject(id);
	self:run(connection);
end;

function SetCoverSheetEvent:writeStream(streamId, connection)
	streamWriteInt32(streamId, networkGetObjectId(self.vehicle));
	streamWriteBool(streamId, self.state);
end;

function SetCoverSheetEvent:run(connection)
	self.vehicle:setCoverSheet(self.state, true);
	if not connection:getIsServer() then
		g_server:broadcastEvent(SetCoverSheetEvent:new(self.vehicle, self.state), nil, connection, self.vehicle);
	end;
end;

function SetCoverSheetEvent.sendEvent(vehicle, state, noEventSend)
	if state ~= vehicle.multiT.coverSheet then
		if noEventSend == nil or noEventSend == false then
			if g_server ~= nil then
				g_server:broadcastEvent(SetCoverSheetEvent:new(vehicle, state), nil, nil, vehicle);
			else
				g_client:getServerConnection():sendEvent(SetCoverSheetEvent:new(vehicle, state));
			end;
		end;
	end;
end;


SetUnloadingObjectsEvent = {};
SetUnloadingObjectsEvent_mt = Class(SetUnloadingObjectsEvent, Event);

InitEventClass(SetUnloadingObjectsEvent, "SetUnloadingObjectsEvent");

function SetUnloadingObjectsEvent:emptyNew()
	local self = Event:new(SetUnloadingObjectsEvent_mt);
	self.className="SetUnloadingObjectsEvent";
	return self;
end;

function SetUnloadingObjectsEvent:new(vehicle, state)
	local self = SetUnloadingObjectsEvent:emptyNew()
	self.vehicle = vehicle;
	self.state = state;
	return self;
end;

function SetUnloadingObjectsEvent:readStream(streamId, connection)
	local id = streamReadInt32(streamId);
	self.state = streamReadBool(streamId);
	self.vehicle = networkGetObject(id);
	self:run(connection);
end;

function SetUnloadingObjectsEvent:writeStream(streamId, connection)
	streamWriteInt32(streamId, networkGetObjectId(self.vehicle));
	streamWriteBool(streamId, self.state);
end;

function SetUnloadingObjectsEvent:run(connection)
	self.vehicle:setUnloadingObjects(self.state, true);
	if not connection:getIsServer() then
		g_server:broadcastEvent(SetUnloadingObjectsEvent:new(self.vehicle, self.state), nil, connection, self.vehicle);
	end;
end;

function SetUnloadingObjectsEvent.sendEvent(vehicle, state, noEventSend)
	if state ~= vehicle.multiT.unloading then
		if noEventSend == nil or noEventSend == false then
			if g_server ~= nil then
				g_server:broadcastEvent(SetUnloadingObjectsEvent:new(vehicle, state), nil, nil, vehicle);
			else
				g_client:getServerConnection():sendEvent(SetUnloadingObjectsEvent:new(vehicle, state));
			end;
		end;
	end;
end;


SetOpenableSidewallsEvent = {};
SetOpenableSidewallsEvent_mt = Class(SetOpenableSidewallsEvent, Event);

InitEventClass(SetOpenableSidewallsEvent, "SetOpenableSidewallsEvent");

function SetOpenableSidewallsEvent:emptyNew()
	local self = Event:new(SetOpenableSidewallsEvent_mt);
	self.className="SetOpenableSidewallsEvent";
	return self;
end;

function SetOpenableSidewallsEvent:new(vehicle, side, state)
	local self = SetOpenableSidewallsEvent:emptyNew()
	self.vehicle = vehicle;
	self.side = side;
	self.state = state;
	return self;
end;

function SetOpenableSidewallsEvent:readStream(streamId, connection)
	local id = streamReadInt32(streamId);
	self.side = streamReadString(streamId);
	self.state = streamReadBool(streamId);
	self.vehicle = networkGetObject(id);
	self:run(connection);
end;

function SetOpenableSidewallsEvent:writeStream(streamId, connection)
	streamWriteInt32(streamId, networkGetObjectId(self.vehicle));
	streamWriteString(streamId, self.side);
	streamWriteBool(streamId, self.state);
end;

function SetOpenableSidewallsEvent:run(connection)
	self.vehicle:setOpenableSidewalls(self.side, self.state, true);
	if not connection:getIsServer() then
		g_server:broadcastEvent(SetOpenableSidewallsEvent:new(self.vehicle, self.side, self.state), nil, connection, self.vehicle);
	end;
end;

function SetOpenableSidewallsEvent.sendEvent(vehicle, side, state, noEventSend)
	if (side == "left" and state ~= vehicle.multiT.leftSidewall.isOpen) or (side == "right" and state ~= vehicle.multiT.rightSidewall.isOpen) then
		if noEventSend == nil or noEventSend == false then
			if g_server ~= nil then
				g_server:broadcastEvent(SetOpenableSidewallsEvent:new(vehicle, side, state), nil, nil, vehicle);
			else
				g_client:getServerConnection():sendEvent(SetOpenableSidewallsEvent:new(vehicle, side, state));
			end;
		end;
	end;
end;